
<div class="row row-head">
  <div class="col">
    <h2 class="title">Quotes Management</h2>
  </div>
  <div class="col text-right">
    <button type="button" class="btn btn-primary mt-3" (click)="createNew()">
      <i class="fa fa-plus"></i>
      New Quote
    </button>
  </div>
</div>
<div class="row">
  <div class="col">
    <div class="table-responsive">
      <form (submit)="saveQuote()">
        <table class="table">
          <thead>
            <tr>
              <th>
                Id
              </th>
              <th style="max-width:300px;">
                Quote
              </th>
              <th>
                Author
              </th>
              <th>
                Last Modified
              </th>
              <th>
                Actions
              </th>
            </tr>
          </thead>
          <tbody>
            <tr *ngIf="createMode">
              <td></td>
              <td style="max-width:300px;">
                <textarea class="form-control" name="text" rows="4" [(ngModel)]="model.text" autofocus></textarea>
              </td>
              <td>
                <select class="form-control" name="author" [(ngModel)]="model.authorId" *ngIf="!newAuthor">
                  <option value="0">Select Author</option>
                  <option *ngFor="let item of authors" [ngValue]="item.id">{{item.name}}</option>
                </select>
                <button type="button" class="btn btn-link btn-sm" *ngIf="!newAuthor" (click)="toggleAuthors(true)">
                  New Author
                </button>
                <input type="text" name="authorname" class="form-control" [(ngModel)]="model.authorName" *ngIf="newAuthor" />
                <button type="button" class="btn btn-link btn-sm" *ngIf="newAuthor" (click)="toggleAuthors(false)">
                  Select Author
                </button>
              </td>
              <td></td>
              <td class="action-btns">
                <button type="submit" class="btn btn-success btn-sm" style="width:100px;" *ngIf="!saving">
                  Save
                </button>
                <button type="button" class="btn btn-success btn-sm" style="width:100px;" disabled *ngIf="saving">
                  <i class="fa fa-spin fa-spinner"></i>
                </button>
                <button type="button" class="btn btn-secondary btn-sm" (click)="createCancel()">
                  Cancel
                </button>
              </td>
            </tr>
            <tr *ngFor="let item of quotes">
              <td>
                {{item.id}}
              </td>
              <td style="max-width:300px;">
                <span *ngIf="editId != item.id">
                  {{item.text}}
                </span>
                <textarea class="form-control" name="text" rows="4" [(ngModel)]="model.text" autofocus *ngIf="editId == item.id"></textarea>
              </td>
              <td>
                <span *ngIf="editId != item.id">
                  {{item.authorName}}
                </span>
                <div *ngIf="editId == item.id">
                  <select class="form-control" name="author" [(ngModel)]="model.authorId" *ngIf="!newAuthor">
                    <option value="0">Select Author</option>
                    <option *ngFor="let item of authors" [ngValue]="item.id">{{item.name}}</option>
                  </select>
                  <button type="button" class="btn btn-link btn-sm" *ngIf="!newAuthor" (click)="toggleAuthors(true)">
                    New Author
                  </button>
                  <input type="text" name="authorname" class="form-control" [(ngModel)]="model.authorName" *ngIf="newAuthor" />
                  <button type="button" class="btn btn-link btn-sm" *ngIf="newAuthor" (click)="toggleAuthors(false)">
                    Select Author
                  </button>
                </div>
              </td>
              <td>
                {{item.lastModified}}
              </td>
              <td class="action-btns">
                <div *ngIf="editId != item.id">
                  <button type="button" class="btn btn-info btn-sm" (click)="editItem(item)">
                    <i class="fa fa-edit"></i>
                  </button>
                  <button type="button" class="btn btn-danger btn-sm" (click)="deleteShow(item)">
                    <i class="fa fa-trash"></i>
                  </button>
                </div>
                <div *ngIf="editId == item.id">
                  <button type="submit" class="btn btn-success btn-sm" style="width:100px;" *ngIf="!saving">
                    Save
                  </button>
                  <button type="button" class="btn btn-success btn-sm" style="width:100px;" disabled *ngIf="saving">
                    <i class="fa fa-spin fa-spinner"></i>
                  </button>
                  <button type="button" class="btn btn-secondary btn-sm" (click)="createCancel()">
                    Cancel
                  </button>
                </div>
              </td>
            </tr>
          </tbody>
        </table>

      </form>
    </div>
  </div>
</div>
<div className="row">
  <div className="col">
    <ul class="pagination">
      <li *ngFor="let p of pages" class="page-item {{(currentPage == p ? 'active' : '')}}">
        <a class="page-link" href="javascript:;" (click)="goToPage(p)">{{p}}</a>
      </li>
    </ul>
  </div>
</div>
<div class="modal fade {{(errShow ? 'modal-show' : '')}}" role="dialog">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-body">
        {{errText}}
      </div>
      <div class="modal-footer" align="right">
        <button type="button" id="btnClose" class="btn btn-secondary" (click)="closeModals()">
           Ok
        </button>
      </div>
    </div>
  </div>
</div>

<div class="modal fade {{(deleteModalShow ? 'modal-show' : '')}}" role="dialog">
  <div class="modal-dialog modal-lg">
    <div class="modal-content">
      <div class="modal-body">
        <p>Are you sure you want to delete this item?</p>
        <blockquote>
          <p>{{deleteSelectedItem != null ? deleteSelectedItem.text : ""}}</p>
          <p style="text-align:right; font-size:12px;">{{deleteSelectedItem != null ? deleteSelectedItem.authorName : ""}}</p>
        </blockquote>
      </div>
      <div class="modal-footer" align="right">
        <button type="button" class="btn btn-danger" (click)="deleteQuote()" style="width:200px;">
          <span *ngIf="!deleting">Confirm And Delete</span>
          <i *ngIf="deleting" class="fa fa-spin fa-spinner"></i>
        </button>
        <button type="button" class="btn btn-secondary" (click)="closeModals()">
          Cancel
        </button>
      </div>
    </div>
  </div>
</div>
